models/Formulario.php
<?php
namespace app\models;
use Yii;
use yii\base\Model;

class Formulario extends Model{
    public $nombre;
    public $edad;
    public $apellidos;
    public $peso;
    public $altura;
    public $poblacion;


    public function rules(){// nos permite definir las reglas de negocio
        
        return [
          [['nombre','edad','peso','altura'],"required",'message'=>"El campo {attribute} no puede estar vacio"],
            ['edad','integer','message'=>'El campo edad debe ser numerico'],
            ['nombre','string','max'=>20],
            ['peso','integer'],
            ['altura','integer','min'=>100,'max'=>250,"message"=>"El campo {attribute} no debe llevar comas ni puntos"],
            ['apellidos','string','max'=>50],
            [['nombre','edad',"poblacion","altura","peso","apellidos"],"safe"],
        ];
    }
    public function attributeLabels() {
        return[
          'nombre'=>'Nombre del trabajador',
          'edad'=>'Edad del trabajador',
          'apellidos'=>'Apellidos del trabajador',
          'peso'=>'Peso del trabajador',
          'altura'=>'Altura del trabajador',
          'poblacion'=>'Poblacion del trabajador',
        ];
        
    }
    
    public function getNombreCompleto(){
        $nombre= $this->nombre;
        $apellido= $this->apellidos;
        
        return $nombre." ".$apellido ;
    }
    
    public function getValores(){
        return[
            "Santander"=>"Santander",
            "Potes"=>"Potes",
            "Laredo"=>"Laredo"
        ];
    }
    
    public  function getImc(){
        $peso= $this->peso;
        $altura= $this->altura;
        
        return $peso / ($altura*$altura)*10000;
                
        
    }
}

controllers/FormulariosController.php
<?php

namespace app\controllers;
use yii\web\Controller;
use Yii;
use app\models\Formulario;

class FormulariosController extends Controller{
    
    public function actionIndex(){
        $id=Yii::$app->request->post();
        if($id){
            $mensaje=$id;
        }else{
            return $this->redirect(["formularios/formulario"]);
        }
        
        return $this->render('index',[
            "mensaje"=>'Probando formularios de Yii2',
            "mensaje"=>$mensaje,
           
        ]);
    }
    public function actionFormulario(){
               
        
        return $this->render('formulario',[
            
        ]);
    }
    
    public function actionFormulario1(){
        $model=new Formulario();
        $dato=Yii::$app->request->post();
        if($dato){
        $model->load(Yii::$app->request->post());
        return $this->render("index",[
            "mensaje"=>$model,
        ]);
        }
        
        return $this->render('formulario1',[
            "model"=>$model,
        ]);
    }
    public function actionFormulario2(){
        $model=new Formulario();
        $dato= Yii::$app->request->post();
        if($dato){
            $model->load($dato);
            if($model->validate()){
            $nombreCompleto=$model->getNombreCompleto();
            $imc=$model->getImc();
            return $this->render('index1',[
                "model"=>$model,
            ]);
            
            }
        }
        return $this->render('formulario2',[
            
            "model"=>$model,
        ]);
    }
    
    
    
    
    
    
}

views/formularios/formulario.php
<?php
use \yii\helpers\Html;
?>

<?= Html::beginForm(['formularios/index'], 'post', ['enctype' => 'multipart/form-data']) ?>
<label>Nombre</label>
<?= Html::input('text', 'nombre',Null)?>
<?='<br>'?>
<label>Edad</label>
<?= Html::input('number', 'edad',Null)?>
<?='<br>'?>
<?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
<?= Html::endForm() ?>

views/formularios/formulario1.php
<?php
use yii\helpers\Html;
use yii\widgets\ActiveForm;

$form = ActiveForm::begin([
    'id' => 'login-form',
    'options' => ['class' => 'form-horizontal'],
]); ?>
    <?= $form->field($model, 'nombre') ?>
    <?= $form->field($model, 'edad')?>

    <div class="form-group">
        <div class="col-lg-offset-1 col-lg-11">
            <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
        </div>
    </div>
<?php ActiveForm::end() ?>

views/formularios/formulario2.php
<?php
use yii\helpers\Html;
use yii\widgets\ActiveForm;


$form = ActiveForm::begin([
    'id' => 'formulario2',
    'options' => ['class' => 'form-horizontal'],
]); ?>
    <?=$form->errorSummary($model)?>;
    <?= $form->field($model, 'nombre') ?>
    <?= $form->field($model, 'apellidos')?>
    <?= $form->field($model, 'edad')?>
    <?= $form->field($model, 'peso')?>
    <?= $form->field($model, 'altura')?>
    <?= $form->field($model, 'poblacion')->dropdownList($model->getValores(),
    ['prompt'=>'Selecciona población']
);?>
    
    <div class="form-group">
        <div class="col-lg-offset-1 col-lg-11">
            <?= Html::submitButton('Enviar', ['class' => 'btn btn-primary']) ?>
        </div>
    </div>
<?php ActiveForm::end() ?>

views/formularios/index.php
<?php

var_dump($mensaje);

views/formularios/index1.php
<?php
use yii\widgets\DetailView;
?>
<?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            
            'nombre',
            'apellidos',
            'edad',
            'peso',
            'altura',
            'poblacion',
            [
            'attribute'=>"nombreCompleto",    
            'value'=>function($model){
                return $model->getNombreCompleto();
            }
            ],
            [
            'attribute'=>"IMC",    
            'value'=>function($model){
                return $model->getImc();
            }
            ],
        ],
    ]) ?>